/*
 * Project name:
     adc2leds (LED blinking on 4GPIO with ADC)
 * Copyright:
     (c) MikroElektronika, 2005-2008
 * Description:
     This code demonstrates blinking of diodes connected on GPIO.
     ADC conversion value determinate which diodes go on and off.
 * Test configuration:
     MCU:             PIC12F675
     Dev.Board:       EasyPIC4
     Oscillator:      Internal, 04.000 MHz
     Ext. Modules:    -
     SW:              mikroC v8.0.0.0
 * NOTES:
     - Jumper should be on RA2 at A-D CONVERTER INPUT
*/
//  4led  indicater  program  hiroshi.ouchi /jh7pyu
//   2008.11.08
unsigned int temp;
unsigned int temp1;
unsigned int iad;
int ix;
//
//
void main() {
    //
    ANSEL = 4;                        // Configure AN2 pin as analog
    GPIO = 0;                         // Initialize GPIO port
    CMCON = 7;                        // Turn off comparators
    TRISIO = 0;                       // Configure GPIO as output
    TRISIO.GPIO2 = 1;                 // set pin GP2 as input
    ADCON0.VCFG = 0;                  // Vdd as Vref
    do {                              // beginning of a repeat loop
      iad = Adc_Read(2);             // Read AN2 channel
      //  F(X) =(adin -x)*k + bias
      //
      //  rev. mode  adc-UP : output-down
      // temp = (iad -ix)* -9 ; //gain
      // temp = temp + 1000;

      // p2 upper
      ix = 100  ;//     p2
      if ( iad > ix ){
         temp = (iad -ix)* 4 ; //gain
         temp = temp + 585; // outputoffset
         goto calc;
      }
      // p1 upper
      ix = 35  ; //lowcut  p1   // p2 => p1 comment miss 20081109 change..
      if ( iad > ix ){
         temp = (iad -ix)* 9 ; //gain
         temp = temp + 0; // outputoffset

         goto calc;
      }
      // locut  case
      temp =0;
 calc:
      //  LED disp CALC.
      //  on-off time  + pwm
      //  temp range  0-3ff( same a adinput)
      //  8bit 0 to ff  (led blink control)
      //  0-3XX  led on-off controll
      //  3ff over all on
      temp1 = 0xff - (temp & 0xff);
      if  (temp < 0x3ff){
          GPIO.F5 =0;
      }
      if   ( temp  < 0x300){
         GPIO.F4 =0;
      }
       if   ( temp  < 0x200){
         GPIO.F1 =0;
      }
       if   ( temp  < 0x100){
         GPIO.F0 =0;
      }
      VDelay_ms(temp1/2);
      if ( temp   < 3 ) {
          GPIO.F0 =0;
      } else {
          GPIO.F0 =1;
      }
      if ( temp  >= 0x100){
         GPIO.F1 =1;
      }
      if ( temp  >= 0x200){
         GPIO.F4 =1;
      }
      if ( temp  >= 0x300){
         GPIO.F5 =1;
      }
      // if  data > 20 led on
      if ((temp & 0xff) > 20 ){
          VDelay_ms(50);
      } else {
          VDelay_ms((temp & 0xff)/2 );
      }

    } while (1);
}

